Index: /branches/multi_player_map/src/lib/network/network_manager.cc
===================================================================
--- /branches/multi_player_map/src/lib/network/network_manager.cc	(revision 9040)
+++ /branches/multi_player_map/src/lib/network/network_manager.cc	(revision 9041)
@@ -52,5 +52,4 @@
   /* initialize the references */
   this->networkStream = NULL;
-  this->sharedNetworkData = SharedNetworkData::getInstance();
   this->elapsedTime = 0.0f;
   
@@ -70,4 +69,5 @@
 NetworkManager::~NetworkManager()
 {
+  PRINTF(0)("NetworkManager destructor\n");
   if ( this->networkStream )
   {
@@ -103,5 +103,5 @@
 {
   this->networkStream = new NetworkStream( name, port );
-  this->sharedNetworkData->setDefaultSyncStream(this->networkStream);
+  SharedNetworkData::getInstance()->setDefaultSyncStream(this->networkStream);
   this->networkStream->startHandshake();
   return 1;
@@ -115,8 +115,8 @@
 int NetworkManager::createServer(unsigned int port)
 {
-  this->sharedNetworkData->setHostID(0);
-  this->sharedNetworkData->setGameServer(true);
+  SharedNetworkData::getInstance()->setHostID(0);
+  SharedNetworkData::getInstance()->setGameServer(true);
   this->networkStream = new NetworkStream(port);
-  this->sharedNetworkData->setDefaultSyncStream(this->networkStream);
+  SharedNetworkData::getInstance()->setDefaultSyncStream(this->networkStream);
   this->networkStream->createNetworkGameManager();
   PRINTF(0)("CREATE SERVER\n");
Index: /branches/multi_player_map/src/lib/network/network_manager.h
===================================================================
--- /branches/multi_player_map/src/lib/network/network_manager.h	(revision 9040)
+++ /branches/multi_player_map/src/lib/network/network_manager.h	(revision 9041)
@@ -40,6 +40,6 @@
 
     /** Returns the hostID @return The hostID of the object */
-    inline int getHostID() { return this->sharedNetworkData->getHostID(); }
-    inline bool isGameServer() { return this->sharedNetworkData->isGameServer(); }
+    inline int getHostID() { return SharedNetworkData::getInstance()->getHostID(); }
+    inline bool isGameServer() { return SharedNetworkData::getInstance()->isGameServer(); }
 
 
@@ -58,5 +58,4 @@
     NetworkStream*                   networkStream;       //!< pointer to network stream
 
-    SharedNetworkData*               sharedNetworkData;       //!< reference to the shared data
     float                            elapsedTime;             //!< elapsed time since the last network update
 };
Index: /branches/multi_player_map/src/lib/network/network_stream.cc
===================================================================
--- /branches/multi_player_map/src/lib/network/network_stream.cc	(revision 9040)
+++ /branches/multi_player_map/src/lib/network/network_stream.cc	(revision 9041)
@@ -111,5 +111,4 @@
     serverSocket = NULL;
   }
-
   for ( PeerList::iterator i = peers.begin(); i!=peers.end(); i++)
   {
@@ -133,5 +132,4 @@
     }
   }
-  
   for ( SynchronizeableList::const_iterator it = getSyncBegin(); it != getSyncEnd(); it ++ )
     (*it)->setNetworkStream( NULL );
Index: /branches/multi_player_map/src/story_entities/menu/game_menu.cc
===================================================================
--- /branches/multi_player_map/src/story_entities/menu/game_menu.cc	(revision 9040)
+++ /branches/multi_player_map/src/story_entities/menu/game_menu.cc	(revision 9041)
@@ -510,5 +510,5 @@
       
       this->ipInputLine = new OrxGui::GLGuiInputLine( );
-      this->ipInputLine->setText( "localhost" );
+      this->ipInputLine->setText( "tardis-d08" );
       this->clientNetworkBox->pack( this->ipInputLine );
       this->ipInputLine->connect(SIGNAL(ipInputLine, enterPushed), this, SLOT(GameMenu, connectToServer));
Index: /branches/multi_player_map/src/story_entities/multi_player_world.cc
===================================================================
--- /branches/multi_player_map/src/story_entities/multi_player_world.cc	(revision 9040)
+++ /branches/multi_player_map/src/story_entities/multi_player_world.cc	(revision 9041)
@@ -27,4 +27,6 @@
 #include "network_manager.h"
 #include "network_game_manager.h"
+
+#include "state.h"
 
 
@@ -150,4 +152,6 @@
   delete NetworkGameManager::getInstance();
 
+  State::setOnline( false );
+  
   return ErrorMessage();
 }