Index: /branches/single_player_map/src/lib/event/event_handler.cc
===================================================================
--- /branches/single_player_map/src/lib/event/event_handler.cc	(revision 9043)
+++ /branches/single_player_map/src/lib/event/event_handler.cc	(revision 9044)
@@ -357,6 +357,6 @@
   else
   {
-     SDL_WM_GrabInput(SDL_GRAB_ON);
-     SDL_ShowCursor(SDL_DISABLE);
+//      SDL_WM_GrabInput(SDL_GRAB_ON);
+//      SDL_ShowCursor(SDL_DISABLE);
   }
 }
Index: /branches/single_player_map/src/world_entities/projectiles/laser.cc
===================================================================
--- /branches/single_player_map/src/world_entities/projectiles/laser.cc	(revision 9043)
+++ /branches/single_player_map/src/world_entities/projectiles/laser.cc	(revision 9044)
@@ -140,8 +140,10 @@
 void Laser::draw () const
 {
-  glMatrixMode(GL_MODELVIEW);
-  glPushMatrix();
   glPushAttrib(GL_ENABLE_BIT);
   glDisable(GL_LIGHTING);
+
+  WorldEntity::draw();
+/*  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
 
   float matrix[4][4];
@@ -151,6 +153,7 @@
   glScalef(2.0, 2.0, 2.0);
   this->getModel()->draw();
+  glPopMatrix();*/
+
   glPopAttrib();
-  glPopMatrix();
 }
 
Index: /branches/single_player_map/src/world_entities/space_ships/cruizer.cc
===================================================================
--- /branches/single_player_map/src/world_entities/space_ships/cruizer.cc	(revision 9043)
+++ /branches/single_player_map/src/world_entities/space_ships/cruizer.cc	(revision 9044)
@@ -78,6 +78,6 @@
   dynamic_cast<Element2D*>(this->getWeaponManager().getFixedTarget())->setVisibility( false);
 
-  exit(-1);
-  this->loadModel("models/ships/human_cruizer.obj");
+  this->loadModel("models/ships/human_cruizer.obj", 0.05);
+
 }
 
@@ -92,8 +92,4 @@
 
   this->setSupportedPlaymodes(Playable::Full3D | Playable::Horizontal | Playable::Vertical);
-
-  this->loadModel("models/ships/hoverglider_wing.obj", 1.0f, 3);
-  this->loadModel("models/ships/hoverglider_turbine.obj", 1.0f, 4);
-  this->loadModel("models/ships/hoverglider_turbine_rotors.obj", 1.0f, 5);
 
   bForward = bBackward = bLeft = bRight = bAscend = bDescend = false;
@@ -117,38 +113,15 @@
   //this->cameraNode.setParent(this);
 
-  // rotors
-  this->wingNodeLeft.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT );
-  this->wingNodeLeft.addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
-  this->wingNodeLeft.setParent(this);
-  this->wingNodeLeft.setRelCoor(-1.5, -.3, -1.0);
-  this->rotorNodeLeft.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
-  this->rotorNodeLeft.setParent(&this->wingNodeLeft);
-  this->rotorNodeLeft.setRelCoor(0, 1.0, -2.3);
-
-  this->wingNodeRight.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
-  this->wingNodeRight.addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
-  this->wingNodeRight.setParent(this);
-  this->wingNodeRight.setRelCoor(-1.5, -0.3, 1.0);
-  this->rotorNodeRight.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
-  this->rotorNodeRight.setParent(&this->wingNodeRight);
-  this->rotorNodeRight.setRelCoor(0, 1.0, 2.3);
 
   // PARTICLES
-  this->burstEmitter[0] = new DotEmitter(200, 5.0, .01);
-  this->burstEmitter[0]->setParent(&this->rotorNodeLeft);
-  this->burstEmitter[0]->setRelCoor(0, -0.7, 0);
-  this->burstEmitter[0]->setRelDir(Quaternion(-M_PI_2, Vector(0,0,1)));
-  this->burstEmitter[0]->setName("Cruizer_Burst_emitter_Left");
-
-  this->burstEmitter[1] = new DotEmitter(200, 5.0, .01);
-  this->burstEmitter[1]->setParent(&this->rotorNodeRight);
-  this->burstEmitter[1]->setRelCoor(0, -0.7, 0);
-  this->burstEmitter[1]->setRelDir(Quaternion(-M_PI_2, Vector(0,0,1)));
-  this->burstEmitter[1]->setName("Cruizer_Burst_emitter_Right");
+  this->burstEmitter = new DotEmitter(200, 5.0, .01);
+  this->burstEmitter->setParent(this);
+  this->burstEmitter->setRelCoor(0, -0.7, 0);
+  this->burstEmitter->setRelDir(Quaternion(-M_PI_2, Vector(0,0,1)));
+  this->burstEmitter->setName("Cruizer_Burst_emitter_Left");
 
 
   this->burstSystem = new SpriteParticles(1000);
-  this->burstSystem->addEmitter(this->burstEmitter[0]);
-  this->burstSystem->addEmitter(this->burstEmitter[1]);
+  this->burstSystem->addEmitter(this->burstEmitter);
   this->burstSystem->setName("SpaceShip_Burst_System");
   ((SpriteParticles*)this->burstSystem)->setMaterialTexture("maps/radial-trans-noise.png");
@@ -181,10 +154,4 @@
   this->getWeaponManager().setSlotCount(5);
 
-  this->getWeaponManager().setSlotPosition(0, Vector(-0.28, 1.186, -2.750), &this->wingNodeLeft);
-  this->getWeaponManager().setSlotCapability(0, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-
-  this->getWeaponManager().setSlotPosition(1, Vector(-0.28, 1.186, 2.750), &this->wingNodeRight);
-  this->getWeaponManager().setSlotCapability(1, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-
   this->getWeaponManager().setSlotPosition(2, Vector(-1.63, .809, -.003));
   this->getWeaponManager().setSlotCapability(2, WTYPE_HEAVY);
@@ -352,68 +319,7 @@
 
         this->setRelDirSoft(this->direction * Quaternion(-cameraLook, Vector(0,0,1)), 5);
-
-        this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-        this->rotorNodeLeft.setRelDirSoft(Quaternion(-accel.x * .07+this->rotation + cameraLook, Vector(0,0,1)), 5);
-
-        this->wingNodeRight.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-        this->rotorNodeRight.setRelDirSoft(Quaternion(-accel.x*.07 -this->rotation + cameraLook, Vector(0,0,1)), 5);
-      }
+     }
       break;
 
-    case Playable::Horizontal:
-      {
-        accel.y = 0.0;
-        Vector accelerationDir = this->getAbsDir().apply(accel * this->acceleration);
-        accelerationDir.y = 0.0;
-
-        // this is the air friction (necessary for a smooth control)
-        Vector damping = (this->velocity * this->airFriction);
-
-
-        this->velocity += (accelerationDir - damping)* dt;
-        this->shiftCoor (this->velocity * dt);
-
-        // limit the maximum rotation speed.
-        if (this->rotation != 0.0f)
-        {
-          float maxRot = 10.0 * dt;
-          if (unlikely(this->rotation > maxRot)) this->rotation = maxRot;
-          if (unlikely(this->rotation < -maxRot)) this->rotation = -maxRot;
-          this->direction *= Quaternion(-M_PI/4.0*this->rotation, Vector(0,1,0));
-
-          this->rotation = 0.0f;
-        }
-
-        this->setRelDirSoft(this->direction, 5);
-
-        this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-        this->rotorNodeLeft.setRelDirSoft(Quaternion(-accel.x * .07+this->rotation, Vector(0,0,1)), 5);
-
-        this->wingNodeRight.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-        this->rotorNodeRight.setRelDirSoft(Quaternion(-accel.x*.07 -this->rotation, Vector(0,0,1)), 5);
-      }
-      break;
-
-    case Playable::Vertical:
-    {
-      accel.z = 0;
-      Vector accelerationDir = this->getAbsDir().apply(accel * this->acceleration);
-      accelerationDir.z=0;
-
-        // this is the air friction (necessary for a smooth control)
-      Vector damping = (this->velocity * this->airFriction);
-
-      this->velocity += (accelerationDir - damping)* dt;
-      this->shiftCoor (this->velocity * dt);
-
-      this->setRelDirSoft(this->direction * Quaternion(-cameraLook, Vector(0,0,1)), 5);
-
-      this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-      this->rotorNodeLeft.setRelDirSoft(Quaternion(-accel.x * .07+this->rotation + cameraLook, Vector(0,0,1)), 5);
-
-      this->wingNodeRight.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-      this->rotorNodeRight.setRelDirSoft(Quaternion(-accel.x*.07 -this->rotation + cameraLook, Vector(0,0,1)), 5);
-    }
-    break;
     default:
       PRINTF(2)("Playmode %s Not Implemented\n", Playable::playmodeToString(this->getPlaymode()).c_str());
@@ -426,48 +332,4 @@
   Vector tmpRot;
   WorldEntity::draw();
-
-  glPushMatrix();
-  /// LEFT SIDE
-  glTranslatef (this->wingNodeLeft.getAbsCoor ().x,
-                this->wingNodeLeft.getAbsCoor ().y,
-                this->wingNodeLeft.getAbsCoor ().z);
-  tmpRot = this->wingNodeLeft.getAbsDir().getSpacialAxis();
-  glRotatef (this->wingNodeLeft.getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-  this->getModel(3)->draw();
-  glPopMatrix ();
-
-  glPushMatrix();
-  glTranslatef (this->rotorNodeLeft.getAbsCoor ().x,
-                this->rotorNodeLeft.getAbsCoor ().y,
-                this->rotorNodeLeft.getAbsCoor ().z);
-  tmpRot = this->rotorNodeLeft.getAbsDir().getSpacialAxis();
-  glRotatef (this->rotorNodeLeft.getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-  this->getModel(4)->draw();
-  glRotatef(this->rotorCycle, 0,1,0);
-  this->getModel(5)->draw();
-  glPopMatrix ();
-
-  /// RIGHT SIDE
-  glPushMatrix();
-  glTranslatef (this->wingNodeRight.getAbsCoor ().x,
-                this->wingNodeRight.getAbsCoor ().y,
-                this->wingNodeRight.getAbsCoor ().z);
-  tmpRot = this->wingNodeRight.getAbsDir().getSpacialAxis();
-  glRotatef (this->wingNodeRight.getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-  glScalef(1,1,-1);
-  this->getModel(3)->draw();
-  glPopMatrix ();
-
-  glPushMatrix();
-  glTranslatef (this->rotorNodeRight.getAbsCoor ().x,
-                this->rotorNodeRight.getAbsCoor ().y,
-                this->rotorNodeRight.getAbsCoor ().z);
-  tmpRot = this->rotorNodeRight.getAbsDir().getSpacialAxis();
-  glRotatef (this->rotorNodeRight.getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-  glScalef(1,1,-1);
-  this->getModel(4)->draw();
-  glRotatef(this->rotorCycle, 0,1,0);
-  this->getModel(5)->draw();
-  glPopMatrix ();
 }
 
Index: /branches/single_player_map/src/world_entities/space_ships/cruizer.h
===================================================================
--- /branches/single_player_map/src/world_entities/space_ships/cruizer.h	(revision 9043)
+++ /branches/single_player_map/src/world_entities/space_ships/cruizer.h	(revision 9044)
@@ -50,9 +50,4 @@
     float                 mouseSensitivity;   //!< the mouse sensitivity
 
-    PNode                 wingNodeLeft;
-    PNode                 wingNodeRight;
-    PNode                 rotorNodeLeft;
-    PNode                 rotorNodeRight;
-
     PNode                 cameraNode;
     float                 cameraLook;
@@ -70,5 +65,5 @@
     float                 airViscosity;
 
-    ParticleEmitter*      burstEmitter[2];
+    ParticleEmitter*      burstEmitter;
     ParticleSystem*       burstSystem;
 };