Index: /branches/single_player_map/src/defs/class_id.h
===================================================================
--- /branches/single_player_map/src/defs/class_id.h	(revision 9045)
+++ /branches/single_player_map/src/defs/class_id.h	(revision 9046)
@@ -199,5 +199,6 @@
   CL_HOVER                      =    0x0000035e,
   CL_TURBINE_HOVER              =    0x0000035f,
-  CL_CRUIZER                    =    0x00000360,
+  CL_SPACECRAFT_2D              =    0x00000360,
+  CL_CRUIZER                    =    0x00000361,
   CL_SPECTATOR                  =    0x0000036a,
   CL_COLLISION_PROBE            =    0x0000036b,
Index: /branches/single_player_map/src/world_entities/WorldEntities.am
===================================================================
--- /branches/single_player_map/src/world_entities/WorldEntities.am	(revision 9045)
+++ /branches/single_player_map/src/world_entities/WorldEntities.am	(revision 9046)
@@ -44,4 +44,5 @@
                 world_entities/space_ships/hover.cc \
                 world_entities/space_ships/turbine_hover.cc \
+                world_entities/space_ships/spacecraft_2d.cc \
                 world_entities/space_ships/collision_probe.cc \
                 world_entities/space_ships/cruizer.cc \
@@ -108,4 +109,5 @@
                 space_ships/hover.h \
                 space_ships/turbine_hover.h \
+                space_ships/spacecraft_2d.h \
                 space_ships/collision_probe.h \
                 space_ships/cruizer.h \
Index: /branches/single_player_map/src/world_entities/space_ships/cruizer.cc
===================================================================
--- /branches/single_player_map/src/world_entities/space_ships/cruizer.cc	(revision 9045)
+++ /branches/single_player_map/src/world_entities/space_ships/cruizer.cc	(revision 9046)
@@ -91,5 +91,5 @@
   this->setClassID(CL_CRUIZER, "Cruizer");
 
-  this->setSupportedPlaymodes(Playable::Full3D | Playable::Horizontal | Playable::Vertical);
+  this->setSupportedPlaymodes(Playable::Full3D);
 
   bForward = bBackward = bLeft = bRight = bAscend = bDescend = false;
Index: /branches/single_player_map/src/world_entities/space_ships/spacecraft_2d.cc
===================================================================
--- /branches/single_player_map/src/world_entities/space_ships/spacecraft_2d.cc	(revision 9045)
+++ /branches/single_player_map/src/world_entities/space_ships/spacecraft_2d.cc	(revision 9046)
@@ -102,11 +102,8 @@
   this->setClassID(CL_SPACECRAFT_2D, "Spacecraft2D");
 
-  this->setSupportedPlaymodes(Playable::Full3D | Playable::Horizontal | Playable::Vertical);
-
-  this->loadModel("models/ships/hoverglider_wing.obj", 1.0f, 3);
-  this->loadModel("models/ships/hoverglider_turbine.obj", 1.0f, 4);
-  this->loadModel("models/ships/hoverglider_turbine_rotors.obj", 1.0f, 5);
-
-  bForward = bBackward = bLeft = bRight = bAscend = bDescend = false;
+  this->setSupportedPlaymodes(Playable::Full3D | Playable::Horizontal);
+
+
+  bForward = bBackward = bLeft = bRight = false;
   mouseSensitivity = 0.005;
 
@@ -123,5 +120,4 @@
 
   // camera - issue
-  this->cameraNode.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
   this->cameraNode.addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
   //this->cameraNode.setParentMode(PNODE_ROTATE_MOVEMENT);
@@ -129,37 +125,14 @@
 
   // rotors
-  this->wingNodeLeft.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT );
-  this->wingNodeLeft.addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
-  this->wingNodeLeft.setParent(this);
-  this->wingNodeLeft.setRelCoor(-1.5, -.3, -1.0);
-  this->rotorNodeLeft.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
-  this->rotorNodeLeft.setParent(&this->wingNodeLeft);
-  this->rotorNodeLeft.setRelCoor(0, 1.0, -2.3);
-
-  this->wingNodeRight.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
-  this->wingNodeRight.addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
-  this->wingNodeRight.setParent(this);
-  this->wingNodeRight.setRelCoor(-1.5, -0.3, 1.0);
-  this->rotorNodeRight.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
-  this->rotorNodeRight.setParent(&this->wingNodeRight);
-  this->rotorNodeRight.setRelCoor(0, 1.0, 2.3);
-
   // PARTICLES
-  this->burstEmitter[0] = new DotEmitter(200, 5.0, .01);
-  this->burstEmitter[0]->setParent(&this->rotorNodeLeft);
-  this->burstEmitter[0]->setRelCoor(0, -0.7, 0);
-  this->burstEmitter[0]->setRelDir(Quaternion(-M_PI_2, Vector(0,0,1)));
-  this->burstEmitter[0]->setName("Spacecraft2D_Burst_emitter_Left");
-
-  this->burstEmitter[1] = new DotEmitter(200, 5.0, .01);
-  this->burstEmitter[1]->setParent(&this->rotorNodeRight);
-  this->burstEmitter[1]->setRelCoor(0, -0.7, 0);
-  this->burstEmitter[1]->setRelDir(Quaternion(-M_PI_2, Vector(0,0,1)));
-  this->burstEmitter[1]->setName("Spacecraft2D_Burst_emitter_Right");
+  this->burstEmitter = new DotEmitter(200, 5.0, .01);
+  this->burstEmitter->setParent(this);
+  this->burstEmitter->setRelCoor(0, -0.7, 0);
+  this->burstEmitter->setRelDir(Quaternion(-M_PI_2, Vector(0,0,1)));
+  this->burstEmitter->setName("Spacecraft2D_Burst_emitter_Left");
 
 
   this->burstSystem = new SpriteParticles(1000);
-  this->burstSystem->addEmitter(this->burstEmitter[0]);
-  this->burstSystem->addEmitter(this->burstEmitter[1]);
+  this->burstSystem->addEmitter(this->burstEmitter);
   this->burstSystem->setName("SpaceShip_Burst_System");
   ((SpriteParticles*)this->burstSystem)->setMaterialTexture("maps/radial-trans-noise.png");
@@ -192,8 +165,8 @@
   this->getWeaponManager().setSlotCount(5);
 
-  this->getWeaponManager().setSlotPosition(0, Vector(-0.28, 1.186, -2.750), &this->wingNodeLeft);
+  this->getWeaponManager().setSlotPosition(0, Vector(-0.28, 1.186, -2.750));
   this->getWeaponManager().setSlotCapability(0, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
 
-  this->getWeaponManager().setSlotPosition(1, Vector(-0.28, 1.186, 2.750), &this->wingNodeRight);
+  this->getWeaponManager().setSlotPosition(1, Vector(-0.28, 1.186, 2.750));
   this->getWeaponManager().setSlotCapability(1, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
 
@@ -216,6 +189,4 @@
   registerVar( new SynchronizeableBool( &bLeft, &bLeft, "bLeft", PERMISSION_OWNER ) );
   registerVar( new SynchronizeableBool( &bRight, &bRight, "bRight", PERMISSION_OWNER ) );
-  registerVar( new SynchronizeableBool( &bAscend, &bAscend, "bAscend", PERMISSION_OWNER ) );
-  registerVar( new SynchronizeableBool( &bDescend, &bDescend, "bDescend", PERMISSION_OWNER ) );
   //registerVar( new SynchronizeableQuaternion( &direction, &direction, "direction", PERMISSION_OWNER ) );
   registerVar( new SynchronizeableFloat( &cameraLook, &cameraLook, "cameraLook", PERMISSION_OWNER ) );
@@ -327,13 +298,4 @@
   {
     accel += Vector(0, 0, this->acceleration);
-  }
-
-  if (this->bAscend )
-  {
-    accel += Vector(0, this->acceleration, 0);
-  }
-  if (this->bDescend )
-  {
-    accel -= Vector(0, this->acceleration, 0);
   }
 
@@ -364,9 +326,4 @@
         this->setRelDirSoft(this->direction * Quaternion(-cameraLook, Vector(0,0,1)), 5);
 
-        this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-        this->rotorNodeLeft.setRelDirSoft(Quaternion(-accel.x * .07+this->rotation + cameraLook, Vector(0,0,1)), 5);
-
-        this->wingNodeRight.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-        this->rotorNodeRight.setRelDirSoft(Quaternion(-accel.x*.07 -this->rotation + cameraLook, Vector(0,0,1)), 5);
       }
       break;
@@ -397,10 +354,4 @@
 
         this->setRelDirSoft(this->direction, 5);
-
-        this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-        this->rotorNodeLeft.setRelDirSoft(Quaternion(-accel.x * .07+this->rotation, Vector(0,0,1)), 5);
-
-        this->wingNodeRight.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-        this->rotorNodeRight.setRelDirSoft(Quaternion(-accel.x*.07 -this->rotation, Vector(0,0,1)), 5);
       }
       break;
@@ -419,10 +370,4 @@
 
       this->setRelDirSoft(this->direction * Quaternion(-cameraLook, Vector(0,0,1)), 5);
-
-      this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-      this->rotorNodeLeft.setRelDirSoft(Quaternion(-accel.x * .07+this->rotation + cameraLook, Vector(0,0,1)), 5);
-
-      this->wingNodeRight.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-      this->rotorNodeRight.setRelDirSoft(Quaternion(-accel.x*.07 -this->rotation + cameraLook, Vector(0,0,1)), 5);
     }
     break;
@@ -435,50 +380,5 @@
 void Spacecraft2D::draw() const
 {
-  Vector tmpRot;
   WorldEntity::draw();
-
-  glPushMatrix();
-  /// LEFT SIDE
-  glTranslatef (this->wingNodeLeft.getAbsCoor ().x,
-                this->wingNodeLeft.getAbsCoor ().y,
-                this->wingNodeLeft.getAbsCoor ().z);
-  tmpRot = this->wingNodeLeft.getAbsDir().getSpacialAxis();
-  glRotatef (this->wingNodeLeft.getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-  this->getModel(3)->draw();
-  glPopMatrix ();
-
-  glPushMatrix();
-  glTranslatef (this->rotorNodeLeft.getAbsCoor ().x,
-                this->rotorNodeLeft.getAbsCoor ().y,
-                this->rotorNodeLeft.getAbsCoor ().z);
-  tmpRot = this->rotorNodeLeft.getAbsDir().getSpacialAxis();
-  glRotatef (this->rotorNodeLeft.getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-  this->getModel(4)->draw();
-  glRotatef(this->rotorCycle, 0,1,0);
-  this->getModel(5)->draw();
-  glPopMatrix ();
-
-  /// RIGHT SIDE
-  glPushMatrix();
-  glTranslatef (this->wingNodeRight.getAbsCoor ().x,
-                this->wingNodeRight.getAbsCoor ().y,
-                this->wingNodeRight.getAbsCoor ().z);
-  tmpRot = this->wingNodeRight.getAbsDir().getSpacialAxis();
-  glRotatef (this->wingNodeRight.getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-  glScalef(1,1,-1);
-  this->getModel(3)->draw();
-  glPopMatrix ();
-
-  glPushMatrix();
-  glTranslatef (this->rotorNodeRight.getAbsCoor ().x,
-                this->rotorNodeRight.getAbsCoor ().y,
-                this->rotorNodeRight.getAbsCoor ().z);
-  tmpRot = this->rotorNodeRight.getAbsDir().getSpacialAxis();
-  glRotatef (this->rotorNodeRight.getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-  glScalef(1,1,-1);
-  this->getModel(4)->draw();
-  glRotatef(this->rotorCycle, 0,1,0);
-  this->getModel(5)->draw();
-  glPopMatrix ();
 }
 
@@ -494,8 +394,4 @@
   else if( event.type == KeyMapper::PEV_RIGHT)
     this->bRight = event.bPressed;
-  else if( event.type == KeyMapper::PEV_UP)
-    this->bAscend = event.bPressed; //this->shiftCoor(0,.1,0);
-  else if( event.type == KeyMapper::PEV_DOWN)
-    this->bDescend = event.bPressed; //this->shiftCoor(0,-.1,0);
   else if( event.type == KeyMapper::PEV_FORWARD)
     this->bForward = event.bPressed; //this->shiftCoor(0,.1,0);
Index: /branches/single_player_map/src/world_entities/space_ships/spacecraft_2d.h
===================================================================
--- /branches/single_player_map/src/world_entities/space_ships/spacecraft_2d.h	(revision 9045)
+++ /branches/single_player_map/src/world_entities/space_ships/spacecraft_2d.h	(revision 9046)
@@ -44,14 +44,7 @@
     bool                  bLeft;              //!< left button pressed.
     bool                  bRight;             //!< right button pressed.
-    bool                  bAscend;            //!< ascend button pressed.
-    bool                  bDescend;           //!< descend button presses.
 
     int                   yInvert;
     float                 mouseSensitivity;   //!< the mouse sensitivity
-
-    PNode                 wingNodeLeft;
-    PNode                 wingNodeRight;
-    PNode                 rotorNodeLeft;
-    PNode                 rotorNodeRight;
 
     PNode                 cameraNode;
@@ -70,5 +63,5 @@
     float                 airViscosity;
 
-    ParticleEmitter*      burstEmitter[2];
+    ParticleEmitter*      burstEmitter;
     ParticleSystem*       burstSystem;
 };