Index: /code/branches/shipSelection/data/gui/scripts/ShipSelectionMenu.lua
===================================================================
--- /code/branches/shipSelection/data/gui/scripts/ShipSelectionMenu.lua	(revision 9056)
+++ /code/branches/shipSelection/data/gui/scripts/ShipSelectionMenu.lua	(revision 9057)
@@ -2,14 +2,11 @@
 
 local P = createMenuSheet("ShipSelectionMenu")
-level = nil
 P.activeTabIndexes = {}
 P.scrollbarWidth = 13
-function P.loadShips(levelname)
-    --orxonox.execute("echo " .. levelname)
-    --level = levelname
-end
+
 function P.onLoad()
---[[    P.createLevelList()
-    
+   orxonox.execute("orxout internal_warning Ships= " .. selectedlevel.getShips())
+   P.createLevelList(selectedlevel)
+--[[     
     -- create tabs with desired tab as argument (nil for all)
     P.createFilterTab("Gametypes", "gametype")
@@ -40,7 +37,12 @@
     })--]]
 end
---[[
-function P.createLevelList()
-    P.levelList = {}
+
+function P.createShipList(level)
+
+    orxonox.execute("orxout internal_warning Ships= " .. selectedlevel:getShips())
+    --local stream = selectedlevel:getShips()
+    --local substr = stream
+    --while substr.find(",")
+    --[[
     local size = orxonox.LevelManager:getInstance():getNumberOfLevels()
     local index = 0
@@ -60,6 +62,8 @@
         end
         index = index + 1
-    end
+    end--]]
 end
+
+
 
 function P.createFilterTab(name, tag)
Index: /code/branches/shipSelection/data/gui/scripts/SingleplayerMenu.lua
===================================================================
--- /code/branches/shipSelection/data/gui/scripts/SingleplayerMenu.lua	(revision 9056)
+++ /code/branches/shipSelection/data/gui/scripts/SingleplayerMenu.lua	(revision 9057)
@@ -6,4 +6,5 @@
 P.activeTabIndexes = {}
 P.scrollbarWidth = 13
+selectedlevel = {} -- level for ship selection
 
 function P.onLoad()
@@ -141,12 +142,10 @@
 
 function P.SingleplayerStartButton_clicked(e)
-    local level = P.SingleplayerGetSelectedLevel()
-    if level ~= nil then
-
-        if level:hasTag("shipselection") then
+    selectedlevel = P.SingleplayerGetSelectedLevel()
+    if selectedlevel ~= nil then
+        if selectedlevel:hasTag("shipselection") then
             local shipSelectionMenu = showMenuSheet("ShipSelectionMenu", true)
-            shipSelectionMenu:loadShips(level:getXMLFilename())
         else
-            orxonox.execute("startGame " .. level:getXMLFilename())
+            orxonox.execute("startGame " .. selectedlevel:getXMLFilename())
             hideAllMenuSheets()
 	end
Index: /code/branches/shipSelection/data/levels/tutorial.oxw
===================================================================
--- /code/branches/shipSelection/data/levels/tutorial.oxw	(revision 9056)
+++ /code/branches/shipSelection/data/levels/tutorial.oxw	(revision 9057)
@@ -4,4 +4,5 @@
  tags = "tutorial, shipselection"
  screenshot = "codingtutorial.png"
+ startingships = "spaceshipGhost, spaceshipPirate, spaceshipSpacecruiser"
 />
 
Index: /code/branches/shipSelection/src/orxonox/LevelInfo.cc
===================================================================
--- /code/branches/shipSelection/src/orxonox/LevelInfo.cc	(revision 9056)
+++ /code/branches/shipSelection/src/orxonox/LevelInfo.cc	(revision 9057)
@@ -112,4 +112,19 @@
         this->tagsUpdated();
     }
+    /**
+    @brief
+        Set the starting ship models of the level
+    @param tags
+        A comma-seperated string of all the allowed ship models for the shipselection.
+    */
+    void LevelInfoItem::setShips(const std::string& ships)
+    {
+        SubString substr = SubString(ships, ",", " "); // Split the string into tags.
+        const std::vector<std::string>& strings = substr.getAllStrings();
+        for(std::vector<std::string>::const_iterator it = strings.begin(); it != strings.end(); it++)
+            this->addShip(*it, false);
+
+        this->shipsUpdated();
+    }
 
     /**
@@ -138,4 +153,23 @@
     /**
     @brief
+        Add a ship model to allowed models for the shipselection
+    @param ship
+        The ship model to be added.
+    @param update
+        Whether the comma-seperated string of all ship models should be updated. Default is true.
+    @return
+        Returns true if the ship was successfully added, if the ship was already present it returns false.
+    */
+    bool LevelInfoItem::addShip(const std::string& ship, bool update)
+    {
+        bool success = this->tags_.insert(ship).second;
+        if(update && success)
+            this->tagsUpdated();
+        return success;
+    }
+
+
+    /**
+    @brief
         Updates the comma-seperated string of all tags, if the set of tags has changed.
     */
@@ -156,4 +190,23 @@
     }
 
+    /**
+    @brief
+        Updates the comma-seperated string of all ships, if the set of tags has changed.
+    */
+    void LevelInfoItem::shipsUpdated(void)
+    {
+        std::stringstream stream;
+        std::set<std::string>::iterator temp;
+        for(std::set<std::string>::iterator it = this->ships_.begin(); it != this->ships_.end(); )
+        {
+            temp = it;
+            if(++it == this->ships_.end()) // If this is the last ship we don't add a comma.
+                stream << *temp;
+            else
+                stream << *temp << ", ";
+        }
+
+        this->startingShipsString_ = std::string(stream.str());
+    }
     // LevelInfo
 
@@ -193,4 +246,5 @@
         XMLPortParam(LevelInfo, "screenshot", setScreenshot, getScreenshot, xmlelement, mode);
         XMLPortParam(LevelInfo, "tags", setTags, getTags, xmlelement, mode);
+        XMLPortParam(LevelInfo, "startingships", setShips, getShips, xmlelement, mode);
     }
 
@@ -208,4 +262,5 @@
         info->setScreenshot(this->getScreenshot());
         info->setTags(this->getTags());
+        info->setShips(this->getShips());
         return info;
     }
Index: /code/branches/shipSelection/src/orxonox/LevelInfo.h
===================================================================
--- /code/branches/shipSelection/src/orxonox/LevelInfo.h	(revision 9056)
+++ /code/branches/shipSelection/src/orxonox/LevelInfo.h	(revision 9057)
@@ -24,5 +24,5 @@
  *   Co-authors:
  *      ...
- *
+ *   
  */
 
@@ -115,9 +115,24 @@
             */
             inline bool hasTag(const std::string& tag) const { return this->tags_.find(tag) != this->tags_.end(); } // tolua_export
-
+ 
+            void setShips(const std::string& ships); //!< Set the starting ship models of the level
+            bool addShip(const std::string& ship, bool update = true); //!< Add a model to shipselection
+            /**
+            @brief Get the set of starting ship models the Level allows
+            @return Returns a comma-seperated string of all the allowed ship models for the shipselection.
+            */
+            inline const std::string& getShips(void) const
+                { return this->startingShipsString_; }    
+            /**
+            @brief Get whether the Level allows a specific starting ship model
+            @param ship The ship model for which is checked.
+            @return Returns true if the Level allows the input ship model
+            */
+            inline bool hasShip(const std::string& ship) const { return this->ships_.find(ship) != this->ships_.end(); } // tolua_export        
             /**
             @brief Get the XML-filename of the Level.
             @return Returns the XML-filename (including *.oxw extension) of the Level.
             */
+
             inline const std::string& getXMLFilename(void) const { return this->xmlfilename_; } // tolua_export
 
@@ -134,5 +149,5 @@
         private:
             void tagsUpdated(void); //!< Updates the comma-seperated string of all tags, if the set of tags has changed.
-
+            void shipsUpdated(void); //!< Updates the comma-seperated string of all tags, if the set of tags has changed.
             static void initializeTags(void); //!< Initialize the set of allowed tags.
             /**
@@ -152,4 +167,6 @@
             std::set<std::string> tags_; //!< The set of tags the Level is tagged with.
             std::string tagsString_; //!< The comma-seperated string of all the tags the Level is tagged with.
+            std::set<std::string> ships_; //!< The set of starting ship models the Level allows.
+            std::string startingShipsString_; //!< The comma-seperated string of all the allowed ship models for the shipselection.            
     }; // tolua_export
 
@@ -161,6 +178,6 @@
         - @b description The description of the level.
         - @b screenshot The screenshot of the level.
-        - @b tags A comma-seperated string of tags. Allowed tags are: <em>test</em>, <em>singleplayer</em>, <em>multiplayer</em>, <em>showcase</em>, <em>tutorial</em>, <em>presentation</em>.
-
+        - @b tags A comma-seperated string of tags. Allowed tags are: <em>test</em>, <em>singleplayer</em>, <em>multiplayer</em>, <em>showcase</em>, <em>tutorial</em>, <em>presentation</em>, <em>shipselection</em>.
+        - @b (optional) startingships The comma-seperated string of starting ship models 
         An example would be:
         @code
@@ -176,5 +193,6 @@
     @author
         Damian 'Mozork' Frick
-
+	@edit
+		Matthias Hutter
     @ingroup Orxonox
     */
@@ -223,7 +241,17 @@
             inline const std::string& getTags(void) const
                 { return this->LevelInfoItem::getTags(); }
-
+            /**
+            @brief Set the starting ship models of the level
+            @param A comma-seperated string of all the allowed ship models for the shipselection.
+            */
+            inline void setShips(const std::string& ships)
+                { this->LevelInfoItem::setShips(ships); }
+            /**
+            @brief Get the starting ship models of the level
+            @return Returns a comma-seperated string of all the allowed ship models for the shipselection.
+            */
+            inline const std::string& getShips(void) const
+                { return this->LevelInfoItem::getShips(); }              
             LevelInfoItem* copy(void); //!< Copies the contents of this LevelInfo object to a new LevelInfoItem object.
-
     };
 