Index: /data/trunk/Blender Laumer,Liechti/OgreXMLConverter.log
===================================================================
--- /data/trunk/Blender Laumer,Liechti/OgreXMLConverter.log	(revision 9064)
+++ /data/trunk/Blender Laumer,Liechti/OgreXMLConverter.log	(revision 9064)
@@ -0,0 +1,31 @@
+14:12:57: Creating resource group General
+14:12:57: Creating resource group Internal
+14:12:57: Creating resource group Autodetect
+14:12:57: Registering ResourceManager for type Mesh
+14:12:57: Registering ResourceManager for type Material
+14:12:57: Registering ResourceManager for type Skeleton
+14:12:57: XMLMeshSerializer reading mesh data from /home/laumerf/laumerf-extra-0/testcube.mesh.xml...
+14:12:57: Reading submeshes...
+14:12:57: Reading geometry...
+14:12:57: Geometry done...
+14:12:57: Submeshes done.
+14:12:57: XMLMeshSerializer import successful.
+14:12:57: Reorganising vertex buffers to automatic layout..
+14:12:57: MeshSerializer writing mesh data to /home/laumerf/laumerf-extra-0/testcube.mesh...
+14:12:57: File header written.
+14:12:57: Writing mesh data...
+14:12:57: Writing submesh...
+14:12:57: Exporting submesh texture aliases...
+14:12:57: Submesh texture aliases exported.
+14:12:57: Submesh exported.
+14:12:57: Exporting bounds information....
+14:12:57: Bounds information exported.
+14:12:57: Exporting submesh name table...
+14:12:57: Submesh name table exported.
+14:12:57: Exporting edge lists...
+14:12:57: Edge lists exported
+14:12:57: Mesh data exported.
+14:12:57: MeshSerializer export successful.
+14:12:57: Unregistering ResourceManager for type Skeleton
+14:12:57: Unregistering ResourceManager for type Material
+14:12:57: Unregistering ResourceManager for type Mesh
Index: /data/trunk/Blender Laumer,Liechti/Scene.material
===================================================================
--- /data/trunk/Blender Laumer,Liechti/Scene.material	(revision 9064)
+++ /data/trunk/Blender Laumer,Liechti/Scene.material	(revision 9064)
@@ -0,0 +1,14 @@
+material testCube
+{
+	receive_shadows on
+	technique
+	{
+		pass
+		{
+			ambient 0.500000 0.500000 0.500000 1.000000
+			diffuse 0.640000 0.640000 0.640000 1.000000
+			specular 0.500000 0.500000 0.500000 1.000000 12.500000
+			emissive 0.000000 0.000000 0.000000 1.000000
+		}
+	}
+}
Index: /data/trunk/Blender Laumer,Liechti/testCube.material
===================================================================
--- /data/trunk/Blender Laumer,Liechti/testCube.material	(revision 9064)
+++ /data/trunk/Blender Laumer,Liechti/testCube.material	(revision 9064)
@@ -0,0 +1,14 @@
+material testCube
+{
+	receive_shadows on
+	technique
+	{
+		pass
+		{
+			ambient 0.500000 0.500000 0.500000 1.000000
+			diffuse 0.108051 0.654280 0.251019 1.000000
+			specular 0.500000 0.500000 0.500000 1.000000 12.500000
+			emissive 0.000000 0.000000 0.000000 1.000000
+		}
+	}
+}
Index: /data/trunk/Blender Laumer,Liechti/testcube.mesh.xml
===================================================================
--- /data/trunk/Blender Laumer,Liechti/testcube.mesh.xml	(revision 9064)
+++ /data/trunk/Blender Laumer,Liechti/testcube.mesh.xml	(revision 9064)
@@ -0,0 +1,120 @@
+<mesh>
+	<submeshes>
+		<submesh material="testCube" usesharedvertices="false">
+			<faces count="12">
+				<face v1="0" v2="1" v3="2"/>
+				<face v1="0" v2="2" v3="3"/>
+				<face v1="4" v2="5" v3="7"/>
+				<face v1="5" v2="6" v3="7"/>
+				<face v1="8" v2="9" v3="11"/>
+				<face v1="9" v2="10" v3="11"/>
+				<face v1="12" v2="13" v3="15"/>
+				<face v1="13" v2="14" v3="15"/>
+				<face v1="16" v2="17" v3="18"/>
+				<face v1="16" v2="18" v3="19"/>
+				<face v1="20" v2="21" v3="23"/>
+				<face v1="21" v2="22" v3="23"/>
+			</faces>
+			<geometry vertexcount="24">
+				<vertexbuffer positions="true" normals="true">
+					<vertex>
+						<position x="1.000000" y="1.000000" z="-1.000000"/>
+						<normal x="0.000000" y="-0.000000" z="-1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="1.000000" y="-1.000000" z="-1.000000"/>
+						<normal x="0.000000" y="-0.000000" z="-1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="-1.000000" z="-1.000000"/>
+						<normal x="0.000000" y="-0.000000" z="-1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="1.000000" z="-1.000000"/>
+						<normal x="0.000000" y="-0.000000" z="-1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="1.000000" y="0.999999" z="1.000000"/>
+						<normal x="0.000000" y="0.000000" z="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="1.000000" z="1.000000"/>
+						<normal x="0.000000" y="0.000000" z="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="-1.000000" z="1.000000"/>
+						<normal x="0.000000" y="0.000000" z="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="0.999999" y="-1.000001" z="1.000000"/>
+						<normal x="0.000000" y="0.000000" z="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="1.000000" y="1.000000" z="-1.000000"/>
+						<normal x="1.000000" y="-0.000001" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="1.000000" y="0.999999" z="1.000000"/>
+						<normal x="1.000000" y="-0.000001" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="0.999999" y="-1.000001" z="1.000000"/>
+						<normal x="1.000000" y="-0.000001" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="1.000000" y="-1.000000" z="-1.000000"/>
+						<normal x="1.000000" y="-0.000001" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="1.000000" y="-1.000000" z="-1.000000"/>
+						<normal x="-0.000000" y="-1.000000" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="0.999999" y="-1.000001" z="1.000000"/>
+						<normal x="-0.000000" y="-1.000000" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="-1.000000" z="1.000000"/>
+						<normal x="-0.000000" y="-1.000000" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="-1.000000" z="-1.000000"/>
+						<normal x="-0.000000" y="-1.000000" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="-1.000000" z="-1.000000"/>
+						<normal x="-1.000000" y="0.000000" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="-1.000000" z="1.000000"/>
+						<normal x="-1.000000" y="0.000000" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="1.000000" z="1.000000"/>
+						<normal x="-1.000000" y="0.000000" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="1.000000" z="-1.000000"/>
+						<normal x="-1.000000" y="0.000000" z="-0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="1.000000" y="0.999999" z="1.000000"/>
+						<normal x="0.000000" y="1.000000" z="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="1.000000" y="1.000000" z="-1.000000"/>
+						<normal x="0.000000" y="1.000000" z="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="1.000000" z="-1.000000"/>
+						<normal x="0.000000" y="1.000000" z="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-1.000000" y="1.000000" z="1.000000"/>
+						<normal x="0.000000" y="1.000000" z="0.000000"/>
+					</vertex>
+				</vertexbuffer>
+			</geometry>
+		</submesh>
+	</submeshes>
+</mesh>